PVector origine;

PVector sourisEcran;
PVector sourisMonde;
PVector mouvementSourisEcran;
PVector mouvementSourisMonde;

PVector coinEcranHautGauche;
PVector coinEcranHautDroite;
PVector coinEcranBasGauche;
PVector coinEcranBasDroite;

boolean clic;
boolean drag;
boolean release;
void mousePressed () { clic    = true; drag = true ;}
void mouseReleased() { release = true; drag = false;}

boolean toucheOption = false;
boolean toucheLeft   = false;
boolean toucheRight  = false;
boolean toucheUp     = false;
boolean toucheDown   = false;

// on ne peut pas appuyer sur plus de 2 touches en meme temps -_-'
void keyPressed()  { if (keyCode == SHIFT) { toucheOption  = true ; } 
                     if (keyCode == LEFT ) { toucheLeft    = true ; }
                     if (keyCode == RIGHT) { toucheRight   = true ; }
                     if (keyCode == UP   ) { toucheUp      = true ; }
                     if (keyCode == DOWN ) { toucheDown    = true ; } }
void keyReleased() { if (keyCode == SHIFT) { toucheOption  = false; } 
                     if (keyCode == LEFT ) { toucheLeft    = false; }
                     if (keyCode == RIGHT) { toucheRight   = false; }
                     if (keyCode == UP   ) { toucheUp      = false; }
                     if (keyCode == DOWN ) { toucheDown    = false; } }


boolean montrerRepere = true;
boolean montrerGrille = false;
boolean montrerSouris = false;
float tailleGrille = 100;
boolean pan = false;

Main main;


void setup() {
  frameRate(60);
  size(500, 800);
  origine = new PVector(width/2, height); // coordonnées ecran
  sourisEcran = new PVector(0, 0);
  sourisMonde = new PVector(0, 0);
  
  main = new Main();
}

void draw() {
  installerRepereEtCoordonneesSouris();
  background(76,54,45);
  main.update();
  if (montrerSouris) {montrerSourisMonde(15);}
  if (montrerRepere) { montrerRepere(); }
  if (montrerGrille) { montrerGrille(); }
  clic = false;
  release = false;
}






///////////////////////////////////////////////////////
/////////////// fonctions de dessins de base //////////
///////////////////////////////////////////////////////

// tous les y sont inversés. y est positif vers le haut !
void cercle(PVector a, float r) {
  ellipse(a.x, -a.y, r, r);
}
void ligne (PVector a, PVector b) {
  line (a.x, -a.y, b.x, -b.y);
}
void rectangle (PVector basGauche, PVector taille) {
  rect(basGauche.x, -basGauche.y, taille.x, -taille.y);
}
void courbe (PVector a, PVector b, PVector c, PVector d) {
  bezier(
    a.x, -a.y, 
    b.x, -b.y, 
    c.x, -c.y, 
    d.x, -d.y);
}
void rotatePivot (PVector pivot, float angle) {
  translate(pivot.x,pivot.y);
  rotate(angle);
  translate(-pivot.x,-pivot.y);
}
void deRotatePivot (PVector pivot, float angle) {
  translate(pivot.x,pivot.y);
  rotate(-angle);
  translate(-pivot.x,-pivot.y);
}

///////////////////////////////////////////////////////
/////////// fonctions de dessins secondaires //////////
///////////////////////////////////////////////////////

void ligneHorizontale(float y) {
  ligne(new PVector(limiteEcranGauche(), y), new PVector(limiteEcranDroite(), y));
}

void ligneVerticale(float x) {
  ligne(new PVector(x, limiteEcranHaut()), new PVector(x, limiteEcranBas()));
}

///////////////////////////////////////////////////////
///////////////// repere et souris ////////////////////
///////////////////////////////////////////////////////

void installerRepereEtCoordonneesSouris() {

  // sourisEcran
    // le monde n'intervient pas du tout
    PVector ancienneSourisEcran = sourisEcran.copy();
    sourisEcran = new PVector(mouseX, mouseY);
  
    // deplacement de la souris depuis la derniere frame
    mouvementSourisEcran = sourisEcran.copy().sub(ancienneSourisEcran);


  // Monde

    // l'origine bouge si on pan
    if (drag && pan) { origine.add(mouvementSourisEcran); }

    // calcul de la souris du monde suivant l'origine
    sourisMonde =
      sourisEcran.copy()
      .sub(origine)
      .sub(new PVector(1, 3)); // compensation d'un WTF
    // y vers le haut pour tout ce qui est dans le monde
    sourisMonde.y = -sourisMonde.y;

    // la souris du monde bouge pareil que celle de l'ecran
    // car pour l'instant il n'y a pas de zoom
    mouvementSourisMonde = mouvementSourisEcran.copy();
    mouvementSourisMonde.y = -mouvementSourisMonde.y; 
    
    // coins de l'ecran en coordonnées monde
    coinEcranHautGauche = new PVector(limiteEcranGauche(), limiteEcranHaut());
    coinEcranHautDroite = new PVector(limiteEcranDroite(), limiteEcranHaut());
    coinEcranBasGauche  = new PVector(limiteEcranGauche(), limiteEcranBas());
    coinEcranBasDroite  = new PVector(limiteEcranDroite(), limiteEcranBas());



  // On est pret pour dessiner dans notre repere !
  translate(origine.x, origine.y);
}



float limiteEcranGauche() { return -origine.x      ;}
float limiteEcranDroite() { return width-origine.x ;}
float limiteEcranHaut  () { return origine.y       ;}
float limiteEcranBas   () { return origine.y-height;}


void montrerRepere() {
  noFill(); stroke(130,117,118,82); strokeWeight(2);
  ligneHorizontale(0);
  ligneVerticale(0);
}

void montrerGrille() {
  noFill(); stroke(129,121,122,19); strokeWeight(1);

  // lignes verticales
    int lignesADroites = floor(limiteEcranDroite()/tailleGrille);
    if (lignesADroites > 0) {
      for (int i = 1; i <= lignesADroites; i++) {
        ligneVerticale(i*tailleGrille);
      }
    }
    
    int lignesAGauche = floor(limiteEcranGauche()/tailleGrille);
    if (lignesAGauche < 0) {
      lignesAGauche = -lignesAGauche; // mtn c'est positif
      for (int i = 1; i <= lignesAGauche; i++) {
        ligneVerticale(-i*tailleGrille);
      }
    }

  // lignes horizontales
    int lignesEnHaut = floor(limiteEcranHaut()/tailleGrille);
    if (lignesEnHaut > 0) {
      for (int i = 1; i <= lignesEnHaut; i++) {
        ligneHorizontale(i*tailleGrille);
      }
    }
    
    int lignesEnBas = floor(limiteEcranBas()/tailleGrille);
    if (lignesEnBas < 0) {
      lignesEnBas = -lignesEnBas; // mtn c'est positif
      for (int i = 1; i <= lignesEnBas; i++) {
        ligneHorizontale(-i*tailleGrille);
      }
    }

}


void montrerSourisMonde(float taille) {
  if (drag) { fill(176, 171); noStroke();}
  else      { noFill(); stroke(176, 171); strokeWeight(1);}
  cercle (sourisMonde, taille);
  // deplacement de la souris depuis la derniere frame
  noFill(); stroke(176, 140); strokeWeight(1);
  ligne (sourisMonde, sourisMonde.copy().add(invert(mouvementSourisMonde)));
}



////////////////////////////////////////////////////////////////////////
//////////////////////////fonctions de easing //////////////////////////
////////////////////////////////////////////////////////////////////////
float easeInOut(float valeurDeBase, float valeurFinale, float t) {
  t = clamp(t, 0, 1);
  float difference = valeurFinale - valeurDeBase;
  float imageDeT = (sin(t*PI-PI/2)+1)/2;
  return valeurDeBase + difference*imageDeT ;
}


void afficherCourbeEaseInOutPleine(PVector p1, PVector p2, float base){
  
  PVector trajet = p2.copy().sub(p1);
  PVector p1b = p1.copy();
  PVector p2b = p2.copy();

  // cette valeur permet a la fonction
  // bezier de ressembler a easeInOut
  float a = 0.36;
  p1b.x += trajet.x*a; 
  p2b.x -= trajet.x*a;
  
  // dessin de la courbe
  beginShape();
  vertex(p1.x,-base);
  vertex(p1.x,-p1.y);
  bezierVertex(p1b.x,-p1b.y,p2b.x,-p2b.y,p2.x,-p2.y);
  vertex(p2.x,-base);
  endShape(CLOSE);  
}



////////////////////////////////////////////////////////////////////////
////////////////////////// fonctions maths /////////////////////////////
////////////////////////////////////////////////////////////////////////

float clamp(float a, float borneMin, float borneMax) {
  return min(max(a, borneMin), borneMax);
}
float tendreVers(float but, float valeur, float increment){
  increment = abs(increment);
  if (but - valeur > 0) {
    valeur+= increment;
    if ((but - valeur) < 0) {valeur = but; } 
  }
  else if (but - valeur < 0) {
    valeur-= increment;
    if ((but - valeur) > 0) {valeur = but; } 
  }
  return valeur;
}
static PVector invert(PVector v) {
  return new PVector (-v.x, -v.y);
}
